#pragma semicolon 1
#include <sourcemod>
#define PLUGIN_VERSION "1.2"

new Handle:g_runspeed_enable_spade = INVALID_HANDLE;
new Handle:g_runspeed_enable_knife = INVALID_HANDLE;
new Handle:g_runspeed_speed = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = "DoD:S permanent Speed with Spade/Knife", 
	author = "Darkranger", 
	description = "Gives you permanent Speed when holding Spade or Knife", 
	version = PLUGIN_VERSION, 
	url = "http://www.dodsplugins.net"
}

public OnPluginStart()
{
	g_runspeed_speed = CreateConVar("sm_dods_runspeed", "1.0", "Speed when RunSpeed is enabled", FCVAR_PLUGIN, true, 0.8, true, 1.4);
	g_runspeed_enable_spade = CreateConVar("sm_dods_runspeed_enable_spade", "1", "Enable(1) permanent Speed when holding the Spade", FCVAR_PLUGIN);
	g_runspeed_enable_knife = CreateConVar("sm_dods_runspeed_enable_knife", "1", "Enable(1) permanent Speed when holding the Knife", FCVAR_PLUGIN);
	AutoExecConfig(true, "sm_dods_runspeed", "sm_dods_runspeed");
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if (GetConVarFloat(g_runspeed_enable_spade) > 0)
	{
		decl String:weaponhold[32];
		GetClientWeapon(client, weaponhold, 32);
		if (StrEqual(weaponhold, "weapon_spade"))
		{
			buttons & IN_SPEED && buttons & IN_FORWARD ? SetEntPropFloat(client, Prop_Send, "m_flStamina", 90.0):0;
			buttons & IN_SPEED && buttons & IN_FORWARD ? SetEntPropFloat(client, Prop_Send, "m_flLaggedMovementValue", GetConVarFloat(g_runspeed_speed)):0;
		}
	}
	if (GetConVarFloat(g_runspeed_enable_knife) > 0)
	{
		decl String:weaponhold[32];
		GetClientWeapon(client, weaponhold, 32);
		if (StrEqual(weaponhold, "weapon_amerknife"))
		{
			buttons & IN_SPEED && buttons & IN_FORWARD ? SetEntPropFloat(client, Prop_Send, "m_flStamina", 90.0):0;
			buttons & IN_SPEED && buttons & IN_FORWARD ? SetEntPropFloat(client, Prop_Send, "m_flLaggedMovementValue", GetConVarFloat(g_runspeed_speed)):0;
		}
	}
}

public OnClientPutInServer(client)
{
	CreateTimer(20.0, Announce, client, TIMER_FLAG_NO_MAPCHANGE);
}

public Action:Announce(Handle:timer, any:client)
{
	if (IsClientInGame(client) && GetConVarFloat(g_runspeed_enable_knife) > 0)
	{
		PrintToChat(client, "Permanent Speed is enabled when holding the Knife");
	}
	if (IsClientInGame(client) && GetConVarFloat(g_runspeed_enable_spade) > 0)
	{
		PrintToChat(client, "Permanent Speed is enabled when holding the Spade");
	}
} 